/*
THE SAMPLE CODE IS PROVIDED "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, 
INCLUDING THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A 
PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL ESRI OR CONTRIBUTORS 
BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR 
CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF 
SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS 
INTERRUPTION) SUSTAINED BY YOU OR A THIRD PARTY, HOWEVER CAUSED AND ON ANY 
THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT ARISING 
IN ANY WAY OUT OF THE USE OF THIS SAMPLE CODE, EVEN IF ADVISED OF THE 
POSSIBILITY OF SUCH DAMAGE.
*/

DECLARE @JobName NVARCHAR(128) = N'Index Maintenance Solution'
DECLARE @JobStepName NVARCHAR(128) = N'Collect Command Log Data'
DECLARE @Command NVARCHAR(MAX) = N'--// Set the appropriate permissions and get and clear out the command log.
	GRANT SELECT ON SCHEMA::Maintenance TO [JobExecCredential01];
	GRANT DELETE ON SCHEMA::Maintenance TO [JobExecCredential01];

	SELECT CL.ID,
		   @@SERVERNAME AS AzureSQLServer,
		   CL.DatabaseName,
		   CL.SchemaName,
		   CL.ObjectName,
		   CL.ObjectType,
		   CL.IndexName,
		   CL.IndexType,
		   CL.StatisticsName,
		   CL.PartitionNumber,
		   CL.ExtendedInfo,
		   CL.Command,
		   CL.CommandType,
		   CL.StartTime,
		   CL.EndTime,
		   CL.ErrorNumber,
		   CL.ErrorMessage
	INTO #CLog
	FROM Maintenance.CommandLog AS CL
	;

	DELETE Maintenance.CommandLog;

	SELECT ID,
		   AzureSQLServer,
		   DatabaseName,
		   SchemaName,
		   ObjectName,
		   ObjectType,
		   IndexName,
		   IndexType,
		   StatisticsName,
		   PartitionNumber,
		   ExtendedInfo,
		   Command,
		   CommandType,
		   StartTime,
		   EndTime,
		   ErrorNumber,
		   ErrorMessage
	FROM #CLog
	;'
DECLARE @CredentialName NVARCHAR(128) = N'JobExecCredential01'
DECLARE @TargetGroupName NVARCHAR(128) = N'Index Maintenance Group'

DECLARE @OutputType NVARCHAR(50) = N'SqlDatabase'
DECLARE @OutputCredential NVARCHAR(128) = N'LoadMaintData'
DECLARE @OutputServerName NVARCHAR(256) = N'eus-mssqltips-sql-01.database.windows.net'
DECLARE @OutputDatabaseName NVARCHAR(128) = N'eus-mssqltips-sqldb-01'
DECLARE @OutputSchemaName NVARCHAR(128) = N'Maintenance'
DECLARE @OutputTableName NVARCHAR(128) = N'CentralCommandLog'

EXEC jobs.sp_add_jobstep @job_name = @JobName,
		@step_name = @JobStepName,
		@command = @Command,
		@credential_name = @CredentialName,
		@target_group_name = @TargetGroupName,
		@output_type = @OutputType,
		@output_credential_name = @OutputCredential,
		@output_server_name = @OutputServerName,
		@output_database_name = @OutputDatabaseName,
		@output_schema_name = @OutputSchemaName,
		@output_table_name = @OutputTableName
;
GO